#pragma once

#include <map>

using namespace std;

// ^̍Ē`
// ̍Ē`windows.hȂǂ̃wb_t@CƏd̂Œ
typedef unsigned char  BYTE;  // 1oCgf[^p
typedef unsigned short WORD;  // 2oCgf[^p
typedef unsigned long  DWORD; // 4oCgf[^p

// FourCCpɌ^Ē`
typedef DWORD FOURCC;

// `NID̒`
#define FourCC(c1, c2, c3, c4) (c1 + (c2 << 8) + (c3 << 16) + (c4 << 24)) // `NID쐬p}N
const FOURCC fccRIFF = FourCC('R', 'I', 'F', 'F');
const FOURCC fccLIST = FourCC('L', 'I', 'S', 'T');


// RIFFt@Cǂݍނ߂̃NX
// G[͏ȂĂ邽ߕKvɉĒǉ邱
// ygp@z
//   FOURCC fccTEST =  FourCC('T', 'E', 'S', 'T') ;
//   CRiffLoader rl("test.wav"); // t@CJ
//
//   // w肵`Ñf[^擾
//   // `ÑTCY擾  TCỸobt@mF  f[^obt@Ɏ擾
//   DWORD size = rl.getChunkSize(fccTEST);  // `NTCY擾
//   
//   char* buffer = new [size];              // obt@m
//   rl.getChunkData(fccTEST, buffer, size); // `Nf[^擾
//
class CRiffLoader
{
private:
	FILE* fp;
	DWORD filesize;

	map<FOURCC, DWORD> chunkmap; // `Nf[^̈ʒu(t@C|C^ʒu)̋L^p

public:
	// RXgN^BJt@Cw肷
	CRiffLoader(char filename[]) 
	{
		// t@CJ
		fp = fopen(filename, "rb");
		if (fp == nullptr) { return; }

		// t@CTCY擾
		// fseek(SEEK_END) + ftell()gt@CTCY擾
		// ɂĂ͓삵Ȃ̂Ŋɍ킹ďC邱
		// (Windows 10AVisual Studio 2017 ver15.4.4͂Ԃv)
		fseek(fp, 0, SEEK_END);
		filesize = ftell(fp);
		fseek(fp, 0, SEEK_SET); // t@C̈ʒuŏɖ߂Ă

		// t@C̏I܂ŊmFă`N̈ʒuchunkmapɕۑ
		while ((DWORD)ftell(fp) < filesize)
		{
			// `NID(FourCC)ƃTCYǂݍ
			DWORD chunkID;
			fread(&chunkID, sizeof(FOURCC), 1, fp);

			DWORD chunkSize;
			fread(&chunkSize, sizeof(DWORD), 1, fp);

			switch (chunkID)
			{
			case fccRIFF: // RIFF`NINFO`N̏
			case fccLIST:
				// f[^̍ŏ 4byte(`N^Cv)XLbv
				// c̃f[^̓Tu`NȂ̂ōŏ 4bytê݂Ƃ
				fseek(fp, sizeof(DWORD), SEEK_CUR);

				break;

			default: // ʏ̃`N̏
				// t@C|C^̈ʒuۑĂ
				// (Y`ÑTCŸʒu)
				chunkmap[chunkID] = (DWORD)ftell(fp) - sizeof(DWORD) ;

				// f[^̓XLbv
				fseek(fp, chunkSize, SEEK_CUR);

				break;
			}

		}
	};

	~CRiffLoader()
	{
		// t@C
		fclose(fp);
	}

	// t@CTCY擾
	DWORD getFileSize()
	{
		return filesize;
	};

	// chunkID(FourCC)Ŏw肵`ÑTCY擾
	// s0Aƃ`ÑTCYԂ
	DWORD getChunkSize(FOURCC chunkID)
	{
		// chunkmapchunkID邩mF
		if (chunkmap.count(chunkID) == 0)
		{
			// chunkIDȂ̂0Ԃ
			return 0;
		}

		// t@C|C^̈ʒu`N̏ꏊ܂Ői߂ēǂݍ
		DWORD size = 0;
		fseek(fp, chunkmap[chunkID], SEEK_SET);
		fread(&size, sizeof(DWORD), 1, fp);

		return size;
	}

	// chunkID(FourCC)Ŏw肵`Ñf[^dataɎ擾
	// s0A1Ԃ
	DWORD getChunkData(FOURCC chunkID, void* data, DWORD datasize)
	{
		// chunkmapchunkID邩mF
		if (chunkmap.count(chunkID) == 0)
		{
			// chunkIDȂ̂0Ԃ
			return 0;
		}

		// t@C|C^̈ʒu`N̏ꏊ܂Ői߂ēǂݍ
		DWORD size = 0;
		fseek(fp, chunkmap[chunkID], SEEK_SET);
		fread(&size, sizeof(DWORD), 1, fp);

		size = (datasize > size) ? (size) : datasize;

		fread(data, size, 1, fp);

		return 1;
	}
};
